| LPCOpen Platform v1.03 LPCOpen Platform for NXP LPC Microcontrollers

- Main Page
- Modules
- Data Structures
- Files
- Related Pages

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Enumerations
Read/Write of Multi-Byte Streams
Pipe Data Reading and Writing

## Detailed Description

Pipe data stream transmission and reception management.

Functions, macros, variables, enums and types related to data reading and writing of data streams from and to pipes.

## Enumerations
enum | Pipe_Stream_RW_ErrorCodes_t { PIPE_RWSTREAM_NoError = 0, PIPE_RWSTREAM_PipeStalled = 1, PIPE_RWSTREAM_DeviceDisconnected = 2, PIPE_RWSTREAM_Timeout = 3, PIPE_RWSTREAM_IncompleteTransfer = 4 }

## Enumeration Type Documentation

enum Pipe_Stream_RW_ErrorCodes_t

Enum for the possible error return codes of the Pipe_*_Stream_* functions.

Enumerator:

  PIPE_RWSTREAM_NoError | Command completed successfully, no error.
  PIPE_RWSTREAM_PipeStalled | The device stalled the pipe during the transfer.
  PIPE_RWSTREAM_DeviceDisconnected | Device was disconnected from the host during the transfer.
  PIPE_RWSTREAM_Timeout | The device failed to accept or send the next packet within the software timeout period set by the USB_STREAM_TIMEOUT_MS macro.
  PIPE_RWSTREAM_IncompleteTransfer | Indicates that the pipe bank became full/empty before the complete contents of the stream could be transferred.

Definition at line 63 of file PipeStream.h.

## Function Documentation

uint8_t Pipe_Discard_Stream | ( | const uint8_t | corenum,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Reads and discards the given number of bytes from the pipe, discarding fully read packets from the host as needed. The last packet is not automatically discarded once the remaining bytes has been read; the user is responsible for manually discarding the last packet from the device via the Pipe_ClearIN() macro.

If the BytesProcessed parameter is `NULL`, the entire stream transfer is attempted at once, failing or succeeding as a single unit. If the BytesProcessed parameter points to a valid storage location, the transfer will instead be performed as a series of chunks. Each time the pipe bank becomes empty while there is still data to process (and after the current packet has been acknowledged) the BytesProcessed location will be updated with the total number of bytes processed in the stream, and the function will exit with an error code of PIPE_RWSTREAM_IncompleteTransfer. This allows for any abort checking to be performed in the user code - to continue the transfer, call the function again with identical parameters and it will resume until the BytesProcessed value reaches the total transfer length.

Single Stream Transfer Example:

uint8_t ErrorCode;
if ((ErrorCode = Pipe_Discard_Stream(512, NULL)) != PIPE_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Partial Stream Transfers Example:

uint8_t ErrorCode;
uint16_t BytesProcessed;
BytesProcessed = 0;
while ((ErrorCode = Pipe_Discard_Stream(512, &BytesProcessed)) == PIPE_RWSTREAM_IncompleteTransfer)
{
// Stream not yet complete - do other actions here, abort if required
}
if (ErrorCode != PIPE_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Note
  The pipe token is set automatically, thus this can be used on bi-directional pipes directly without having to explicitly change the data direction with a call to Pipe_SetPipeToken().

Parameters

  corenum | : USB port number
  Length | : Number of bytes to discard via the currently selected pipe
  BytesProcessed | : Pointer to a location where the total number of bytes already processed should updated, `NULL` if the entire stream should be processed at once.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum

Definition at line 39 of file PipeStream.c.

uint8_t Pipe_Null_Stream | ( | const uint8_t | corenum,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Writes a given number of zeroed bytes to the pipe, sending full pipe packets from the host to the device as needed. The last packet is not automatically sent once the remaining bytes has been written; the user is responsible for manually discarding the last packet from the device via the Pipe_ClearOUT() macro.

If the BytesProcessed parameter is `NULL`, the entire stream transfer is attempted at once, failing or succeeding as a single unit. If the BytesProcessed parameter points to a valid storage location, the transfer will instead be performed as a series of chunks. Each time the pipe bank becomes full while there is still data to process (and after the current packet transmission has been initiated) the BytesProcessed location will be updated with the total number of bytes processed in the stream, and the function will exit with an error code of PIPE_RWSTREAM_IncompleteTransfer. This allows for any abort checking to be performed in the user code - to continue the transfer, call the function again with identical parameters and it will resume until the BytesProcessed value reaches the total transfer length.

Single Stream Transfer Example:

uint8_t ErrorCode;
if ((ErrorCode = Pipe_Null_Stream(512, NULL)) != PIPE_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Partial Stream Transfers Example:

uint8_t ErrorCode;
uint16_t BytesProcessed;
BytesProcessed = 0;
while ((ErrorCode = Pipe_Null_Stream(512, &BytesProcessed)) == PIPE_RWSTREAM_IncompleteTransfer)
{
// Stream not yet complete - do other actions here, abort if required
}
if (ErrorCode != PIPE_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Note
  The pipe token is set automatically, thus this can be used on bi-directional pipes directly without having to explicitly change the data direction with a call to Pipe_SetPipeToken().

Parameters

  corenum | : USB port number
  Length | : Number of zero bytes to write via the currently selected pipe
  BytesProcessed | : Pointer to a location where the total number of bytes already processed should updated, `NULL` if the entire stream should be processed at once.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum

Definition at line 80 of file PipeStream.c.

uint8_t Pipe_Read_EStream_BE | ( | void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Pipe Read EEPROM Stream Big Endian.

Parameters

  Buffer | : Pointer to the source data buffer to write to
  Length | : Number of bytes to read for the currently selected pipe to read from
  BytesProcessed | : Pointer to a location where the total number of bytes already processed should updated, `NULL` if the entire stream should be read at once.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum

Definition at line 205 of file PipeStream.c.

uint8_t Pipe_Read_EStream_LE | ( | void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Pipe Read EEPROM Stream Little Endian.

Parameters

  Buffer | : Pointer to the source data buffer to write to
  Length | : Number of bytes to read for the currently selected pipe to read from
  BytesProcessed | : Pointer to a location where the total number of bytes already processed should updated, `NULL` if the entire stream should be read at once.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum

Definition at line 198 of file PipeStream.c.

uint8_t Pipe_Read_Stream_BE | ( | void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Reads the given number of bytes from the pipe into the given buffer in big endian, sending full packets to the device as needed. The last packet filled is not automatically sent; the user is responsible for manually sending the last written packet to the host via the Pipe_ClearIN() macro. Between each USB packet, the given stream callback function is executed repeatedly until the next packet is ready, allowing for early aborts of stream transfers.

Note
  The pipe token is set automatically, thus this can be used on bi-directional pipes directly without having to explicitly change the data direction with a call to Pipe_SetPipeToken().

Parameters

  Buffer | : Pointer to the source data buffer to write to
  Length | : Number of bytes to read for the currently selected pipe to read from
  BytesProcessed | : Pointer to a location where the total number of bytes already processed should updated, `NULL` if the entire stream should be read at once.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum

Definition at line 163 of file PipeStream.c.

uint8_t Pipe_Read_Stream_LE | ( | const uint8_t | corenum,
|  | void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Reads the given number of bytes from the pipe into the given buffer in little endian, sending full packets to the device as needed. The last packet filled is not automatically sent; the user is responsible for manually sending the last written packet to the host via the Pipe_ClearIN() macro. Between each USB packet, the given stream callback function is executed repeatedly until the next packet is ready, allowing for early aborts of stream transfers.

If the BytesProcessed parameter is `NULL`, the entire stream transfer is attempted at once, failing or succeeding as a single unit. If the BytesProcessed parameter points to a valid storage location, the transfer will instead be performed as a series of chunks. Each time the pipe bank becomes empty while there is still data to process (and after the current packet has been acknowledged) the BytesProcessed location will be updated with the total number of bytes processed in the stream, and the function will exit with an error code of PIPE_RWSTREAM_IncompleteTransfer. This allows for any abort checking to be performed in the user code - to continue the transfer, call the function again with identical parameters and it will resume until the BytesProcessed value reaches the total transfer length.

Single Stream Transfer Example:

uint8_t DataStream[512];
uint8_t ErrorCode;
if ((ErrorCode = Pipe_Read_Stream_LE(DataStream, sizeof(DataStream),
NULL)) != PIPE_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Partial Stream Transfers Example:

uint8_t DataStream[512];
uint8_t ErrorCode;
uint16_t BytesProcessed;
BytesProcessed = 0;
while ((ErrorCode = Pipe_Read_Stream_LE(DataStream, sizeof(DataStream),
&BytesProcessed)) == PIPE_RWSTREAM_IncompleteTransfer)
{
// Stream not yet complete - do other actions here, abort if required
}
if (ErrorCode != PIPE_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Note
  The pipe token is set automatically, thus this can be used on bi-directional pipes directly without having to explicitly change the data direction with a call to Pipe_SetPipeToken().

Parameters

  corenum | : USB port number
  Buffer | : Pointer to the source data buffer to write to
  Length | : Number of bytes to read for the currently selected pipe to read from
  BytesProcessed | : Pointer to a location where the total number of bytes already processed should updated, `NULL` if the entire stream should be read at once.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum

Definition at line 116 of file PipeStream.c.

uint8_t Pipe_Streaming | ( | uint8_t | corenum,
|  | uint8_t *const | buffer,
|  | uint32_t const | transferlength,
|  | uint16_t const | packetsize
| ) |  |

Transfer a stream of data to/from USB bus.

Parameters

  corenum | : streaming USB core number
  buffer | : Pointer to the data buffer to read from or write to
  transferlength | : Number of bytes to transfer
  packetsize | : Size in byte of each packet in stream

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum

Definition at line 212 of file PipeStream.c.

uint8_t Pipe_Write_EStream_BE | ( | const void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Pipe Write EEPROM Stream Big Endian.

Parameters

  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected pipe into the buffer
  BytesProcessed | : Pointer to a location where the total number of bytes already processed should updated, `NULL` if the entire stream should be written at once.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum

Definition at line 191 of file PipeStream.c.

uint8_t Pipe_Write_EStream_LE | ( | const void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Pipe Write EEPROM Stream Little Endian.

Parameters

  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected pipe into the buffer
  BytesProcessed | : Pointer to a location where the total number of bytes already processed should updated, `NULL` if the entire stream should be written at once.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum

Definition at line 184 of file PipeStream.c.

uint8_t Pipe_Write_PStream_BE | ( | const void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Pipe Write FLASH Stream Big Endian.

Parameters

  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected pipe into the buffer
  BytesProcessed | : Pointer to a location where the total number of bytes already processed should updated, `NULL` if the entire stream should be written at once.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum

Definition at line 177 of file PipeStream.c.

uint8_t Pipe_Write_PStream_LE | ( | const void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Pipe Write FLASH Stream Little Endian.

Parameters

  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected pipe into the buffer
  BytesProcessed | : Pointer to a location where the total number of bytes already processed should updated, `NULL` if the entire stream should be written at once.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum

Definition at line 170 of file PipeStream.c.

uint8_t Pipe_Write_Stream_BE | ( | const void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Writes the given number of bytes to the pipe from the given buffer in big endian, sending full packets to the device as needed. The last packet filled is not automatically sent; the user is responsible for manually sending the last written packet to the host via the Pipe_ClearOUT() macro. Between each USB packet, the given stream callback function is executed repeatedly until the next packet is ready, allowing for early aborts of stream transfers.

Note
  The pipe token is set automatically, thus this can be used on bi-directional pipes directly without having to explicitly change the data direction with a call to Pipe_SetPipeToken().

Parameters

  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected pipe into the buffer
  BytesProcessed | : Pointer to a location where the total number of bytes already processed should updated, `NULL` if the entire stream should be written at once.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum

Definition at line 156 of file PipeStream.c.

uint8_t Pipe_Write_Stream_LE | ( | const uint8_t | corenum,
|  | const void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Writes the given number of bytes to the pipe from the given buffer in little endian, sending full packets to the device as needed. The last packet filled is not automatically sent; the user is responsible for manually sending the last written packet to the host via the Pipe_ClearOUT() macro. Between each USB packet, the given stream callback function is executed repeatedly until the next packet is ready, allowing for early aborts of stream transfers.

If the BytesProcessed parameter is `NULL`, the entire stream transfer is attempted at once, failing or succeeding as a single unit. If the BytesProcessed parameter points to a valid storage location, the transfer will instead be performed as a series of chunks. Each time the pipe bank becomes full while there is still data to process (and after the current packet transmission has been initiated) the BytesProcessed location will be updated with the total number of bytes processed in the stream, and the function will exit with an error code of PIPE_RWSTREAM_IncompleteTransfer. This allows for any abort checking to be performed in the user code - to continue the transfer, call the function again with identical parameters and it will resume until the BytesProcessed value reaches the total transfer length.

Single Stream Transfer Example:

uint8_t DataStream[512];
uint8_t ErrorCode;
if ((ErrorCode = Pipe_Write_Stream_LE(DataStream, sizeof(DataStream),
NULL)) != PIPE_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Partial Stream Transfers Example:

uint8_t DataStream[512];
uint8_t ErrorCode;
uint16_t BytesProcessed;
BytesProcessed = 0;
while ((ErrorCode = Pipe_Write_Stream_LE(DataStream, sizeof(DataStream),
&BytesProcessed)) == PIPE_RWSTREAM_IncompleteTransfer)
{
// Stream not yet complete - do other actions here, abort if required
}
if (ErrorCode != PIPE_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Note
  The pipe token is set automatically, thus this can be used on bi-directional pipes directly without having to explicitly change the data direction with a call to Pipe_SetPipeToken().

Parameters

  corenum | : USB port number
  Buffer | : Pointer to the source data buffer to read from
  Length | : Number of bytes to read for the currently selected pipe into the buffer
  BytesProcessed | : Pointer to a location where the total number of bytes already processed should updated, `NULL` if the entire stream should be written at once.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum

Definition at line 96 of file PipeStream.c.